<?php
require_once(JPATH_PLUGINS . '/search/sphinxSearchContent/sphinxSearch.lib.php');

class PlgSphinxSearchCategories extends PlgSphinxSearch
{
    function PlgSphinxSearchCategories($hostname, $port, $index)
    {
        parent::PlgSphinxSearch($hostname, $port, $index);
    }

    function getResults()
    {
        $db =& JFactory::getDBO();
        $user   =& JFactory::getUser();
        $accessLevels = $user->getAuthorisedViewLevels();

        $ids = $this->getIds();

        $results = array();
        if (!empty($ids)) {

            $query = 'SELECT a.title, a.description as text, a.created_time as created, "2" AS browsernav, a.id AS catid,'
            . ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug'
            . ' FROM #__categories AS a'
            . ' WHERE a.id in ( ' . implode(', ',$ids) . ')'
            . ' AND ( a.extension="com_content" OR a.extension="system" )'
            . ' AND a.published = 1'
            . ' AND a.access in ( ' . implode(', ',$accessLevels) . ')'
            . ' GROUP BY a.id'
            . " ORDER BY FIELD(a.id, ". implode(', ', $ids) . ")"
            ;

            $db->setQuery($query);
            $results = $db->loadObjectList();

            if (empty ($results)){
                return array();
            }

            // get the actual links from Joomla (maintains clean urls but is probably quite slow)
            foreach($results as $key => $item) {
                $results[$key]->href = ContentHelperRoute::getCategoryRoute($item->catid);
                $results[$key]->section  = JText::_('JCATEGORY');
                $texts[] = strip_tags($results[$key]->text);
            }
            $textSnippets = $this->_sphinx->BuildExcerpts($texts, $this->_index, $this->_query, array("before_match" => '', "after_match" => ''));

            //load snippets
            $counter = 0;
            foreach($results as $key => $item) {
                $results[$key]->text = $textSnippets[$counter++];
            }
	}
        return $results;
    }
}