<?php
require_once(JPATH_PLUGINS . '/search/sphinxSearchContent/sphinxSearch.lib.php');

class PlgSphinxSearchContent extends PlgSphinxSearch
{
    function PlgSphinxSearchContent($hostname, $port, $index)
    {
        parent::PlgSphinxSearch($hostname, $port, $index);
    }

    function getResults()
    {
        $db =& JFactory::getDBO();
        $user   =& JFactory::getUser();
        $accessLevels = $user->getAuthorisedViewLevels();

        $ids = $this->getIds();

        $results = array();
        if (!empty($ids)) {
            $query = 'SELECT a.id, a.catid, a.title AS title, a.metadesc, a.metakey, a.created AS created, a.language, '
		. ' CONCAT(a.introtext, a.fulltext) AS text,'
                . ' b.title AS section,'
                . ' "2" AS browsernav'
		. ' FROM #__content AS a'
                . ' LEFT JOIN #__categories AS b ON b.id=a.catid'
		. ' WHERE a.id in ( ' . implode(', ',$ids) . ')'
                . ' AND a.access in ( ' . implode(', ',$accessLevels) . ')'
                . ' AND IF(b.id, b.access in ( ' . implode(', ',$accessLevels) . '), 1) '
                . ' GROUP BY a.id'
		. " ORDER BY FIELD(a.id, ". implode(', ', $ids) . ")"
            ;

            $db->setQuery($query);
            $results = $db->loadObjectList();

            if (empty ($results)){
                return array();
            }

			// get the actual links from Joomla (maintains clean urls but is probably quite slow)
            foreach($results as $key => $item) {
				$results[$key]->href = ContentHelperRoute::getArticleRoute($item->id, $item->catid, JFactory::getLanguage()->getTag());
                //get text for build snippets
                $texts[] = strip_tags($results[$key]->text);
            }
            $textSnippets = $this->_sphinx->BuildExcerpts($texts, $this->_index, $this->_query, array("before_match" => '', "after_match" => ''));

            //load snippets
            $counter = 0;
            foreach($results as $key => $item) {
                $results[$key]->text = $textSnippets[$counter++];
            }
        }
        return $results;
    }
}