<?php

// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

require_once (JPATH_PLUGINS . '/search/sphinxSearchContent/sphinxapi.php');
require_once (JPATH_PLUGINS . '/search/sphinxSearchContent/sphinxSearchContent.lib.php');
require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');
require_once (JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_search' . DS . 'helpers' . DS . 'search.php');

class plgSearchSphinxSearchContent extends JPlugin {
	
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}
	
	function onContentSearchAreas() {
		static $areas = array (
				'sphinxsearchcontent' => 'PLG_SEARCH_SPHINXSEARCHCONTENT_CONTENT'
		);
		return $areas;
	}
	
	function onContentSearch($text, $phrase = '', $ordering = '', $areas = null) {
		$pServer = $this->params->get('server') == "" ? "localhost": $this->params->get('server');
		$pPort = ( int ) $this->params->get('port') == 0 ? 3312: $this->params->get('port');
		$pIndex = $this->params->get('index');
		$limit = isset ( $_REQUEST ['limit'] ) ? ( int ) $_REQUEST ['limit'] : 50;
		if (0 === $limit) {
			$limit = 1000;
		}
		
		$searchText = $text;
		if (is_array ( $areas )) {
			if (! array_intersect ( $areas, array_keys ( $this->onContentSearchAreas() ) )) {
				return array ();
			}
		}
		
		// clean up our search text
		$text = trim ( $text );
		if ($text == '') {
			return array ();
		}
		
		$sphinxPlugin = new PlgSphinxSearchContent ( $pServer, $pPort, $pIndex );
		$sphinxPlugin->setMatchMode ( $phrase );
		$sphinxPlugin->setOrder ( $ordering );
		$sphinxPlugin->setLimit ( 0, $limit );
		
		$sphinxPlugin->search ( $text );
		
		$results = $sphinxPlugin->getResults ();
		
		// return results back to Joomla
		return $results;
	}
}