<?php

// no direct access
defined ( '_JEXEC' ) or die ( 'Restricted access' );

require_once (JPATH_PLUGINS . '/search/sphinxSearchContent/sphinxapi.php');
require_once (JPATH_PLUGINS . '/search/sphinxSearchNewsfeeds/sphinxSearchNewsfeeds.lib.php');
require_once (JPATH_SITE . DS . 'components' . DS . 'com_content' . DS . 'helpers' . DS . 'route.php');
require_once (JPATH_SITE . DS . 'administrator' . DS . 'components' . DS . 'com_search' . DS . 'helpers' . DS . 'search.php');

class plgSearchSphinxSearchNewsfeeds extends JPlugin {
	
	/**
	 * Constructor
	 *
	 * @access protected
	 * @param object $subject
	 *        	The object to observe
	 * @param array $config
	 *        	An array that holds the plugin configuration
	 * @since 1.5
	 */
	public function __construct(& $subject, $config) {
		parent::__construct ( $subject, $config );
		$this->loadLanguage ();
	}
	
	/**
	 *
	 * @return array An array of search areas
	 */
	function onContentSearchAreas() {
		static $areas = array (
				'sphinxsearchnewsfeeds' => 'PLG_SEARCH_SPHINXSEARCHNEWSFEEDS_NEWSFEEDS' 
		);
		return $areas;
	}
	
	/**
	 * Newsfeeds Search method
	 *
	 * The sql must return the following fields that are used in a common display
	 * routine: href, title, section, created, text, browsernav
	 * @param string Target search string
	 * @param string mathcing option, exact|any|all
	 * @param string ordering option, newest|oldest|popular|alpha|category
	 * @param mixed An array if the search it to be restricted to areas, null if search all
	 */
	function onContentSearch($text, $phrase = '', $ordering = '', $areas = null) {
		$pServer = $this->params->get('server') == "" ? "localhost": $this->params->get('server');
		$pPort = ( int ) $this->params->get('port') == 0 ? 3312: $this->params->get('port');
		$pIndex = $this->params->get('index');
		$limit = isset ( $_REQUEST ['limit'] ) ? ( int ) $_REQUEST ['limit'] : 50;
		if (0 === $limit) {
			$limit = 1000;
		}
		
		$searchText = $text;
		if (is_array ( $areas )) {
			if (! array_intersect ( $areas, array_keys ( $this->onContentSearchAreas() ) )) {
				return array ();
			}
		}
		
		// clean up our search text
		$text = trim ( $text );
		if ($text == '') {
			return array ();
		}
		
		$sphinxPlugin = new PlgSphinxSearchNewsfeeds ( $pServer, $pPort, $pIndex );
		$sphinxPlugin->setMatchMode ( $phrase );
		$sphinxPlugin->setOrder ( $ordering );
		$sphinxPlugin->setLimit ( 0, $limit );
		
		$sphinxPlugin->search ( $text );
		
		$results = $sphinxPlugin->getResults ();
		
		// return results back to Joomla
		return $results;
	}
}