<?php
require_once(JPATH_PLUGINS . '/search/sphinxSearchContent/sphinxSearch.lib.php');

class PlgSphinxSearchWeblinks extends PlgSphinxSearch
{
    function PlgSphinxSearchWeblinks($hostname, $port, $index)
    {
        parent::PlgSphinxSearch($hostname, $port, $index);
    }

    function getResults()
    {
        $db =& JFactory::getDBO();
        $user   =& JFactory::getUser();

        $ids = $this->getIds();

        $results = array();
        if (!empty($ids)) {
        	$section = JText::_( 'Web Links' );
        	$accessLevels = $user->getAuthorisedViewLevels();
        	
        	$tag = JFactory::getLanguage()->getTag();
        	$app	= JFactory::getApplication();
        	$langCondition = ($app->isSite() && $app->getLanguageFilter())?
	        	' AND a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')'
	            . ' AND c.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ') ' : '';
        	
            $query = 'SELECT a.title AS title, a.description AS text, a.created AS created, a.url, '
                . ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug, '
                . ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) ELSE c.id END as catslug, '
                . ' CONCAT_WS(" / ", ' . $db->Quote($section) .', c.title) AS section, '
                . ' "1" AS browsernav'
		. ' FROM #__weblinks AS a INNER JOIN '
                . ' #__categories AS c ON c.id = a.catid '
		. ' WHERE a.id in ( ' . implode(', ',$ids) . ')'
                . ' AND a.state in (1,2) '
                . ' AND c.published = 1 '
                . ' AND c.access in (' . implode(', ',$accessLevels) . ') '
                . $langCondition
		. ' ORDER BY FIELD(a.id, '. implode(', ', $ids) . ')'
            ;

            $db->setQuery($query);
            $results = $db->loadObjectList();

            if (empty ($results)){
                return array();
            }

            // get the actual links from Joomla (maintains clean urls but is probably quite slow)
            foreach($results as $key => $item) {
                $results[$key]->href = WeblinksHelperRoute::getWeblinkRoute($item->slug, $item->catslug);
                $texts[] = strip_tags($results[$key]->text);
            }
            $textSnippets = $this->_sphinx->BuildExcerpts($texts, $this->_index, $this->_query, array("before_match" => '', "after_match" => ''));

            //load snippets
            $counter = 0;
            foreach($results as $key => $item) {
                $results[$key]->text = $textSnippets[$counter++];
            }
	}
        return $results;
    }
}